package nintaco.gui.about;

import java.awt.*;
import javax.swing.*;
import static nintaco.util.VersionUtil.*;
import static nintaco.util.GuiUtil.*;

public class AboutDialog extends javax.swing.JDialog {

  public AboutDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    versionLabel.setText("Version " + getVersion());
    scaleFonts(this);
    imageLabel.setIcon(new ImageIcon(AboutDialog.class.getResource(
        "about.png")));
    nintacoLabel.setFont(scaleFont(getDefaultFont(nintacoLabel), 2.5f));
    getContentPane().setBackground(Color.WHITE);
    aboutPanel.setBackground(Color.WHITE);
    pack();
  }
  
  private void closeDialog() {
    dispose();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    aboutPanel = new javax.swing.JPanel();
    imageLabel = new javax.swing.JLabel();
    nintacoLabel = new javax.swing.JLabel();
    versionLabel = new javax.swing.JLabel();
    copyrightLabel = new javax.swing.JLabel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
    setTitle("About Nintaco");
    setModal(true);
    setPreferredSize(null);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    imageLabel.setBackground(new java.awt.Color(255, 255, 255));
    imageLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    imageLabel.setOpaque(true);

    nintacoLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    nintacoLabel.setText("Nintaco");

    versionLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    versionLabel.setText("Version");
    versionLabel.setMaximumSize(null);
    versionLabel.setMinimumSize(null);
    versionLabel.setPreferredSize(null);

    copyrightLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    copyrightLabel.setText("<html>Copyright &copy; 2017 nintaco.com<br/>\nThis is free software; you can redistribute it<br/> \nand/or modify it under the terms of LGPLv2.1.</html>");
    copyrightLabel.setName(""); // NOI18N

    javax.swing.GroupLayout aboutPanelLayout = new javax.swing.GroupLayout(aboutPanel);
    aboutPanel.setLayout(aboutPanelLayout);
    aboutPanelLayout.setHorizontalGroup(
      aboutPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(aboutPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(imageLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGap(40, 40, 40)
        .addGroup(aboutPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(nintacoLabel)
          .addComponent(versionLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(copyrightLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap())
    );
    aboutPanelLayout.setVerticalGroup(
      aboutPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(aboutPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addGroup(aboutPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(imageLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, aboutPanelLayout.createSequentialGroup()
            .addComponent(nintacoLabel)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(versionLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, Short.MAX_VALUE)
            .addComponent(copyrightLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(aboutPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(aboutPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );
  }// </editor-fold>//GEN-END:initComponents

  private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    closeDialog();
  }//GEN-LAST:event_formWindowClosing

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel aboutPanel;
  private javax.swing.JLabel copyrightLabel;
  private javax.swing.JLabel imageLabel;
  private javax.swing.JLabel nintacoLabel;
  private javax.swing.JLabel versionLabel;
  // End of variables declaration//GEN-END:variables
}
